<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 2/18/16
 * Time: 5:30 PM
 */

namespace qfq;

require_once(__DIR__ . '/../Constants.php');
require_once(__DIR__ . '/../exceptions/UserFormException.php');

class Logger {

    /**
     * Haengt $msg an $filename an
     *
     * @param $msg
     * @param $filename
     * @throws UserFormException
     */
    public static function logMessage($msg, $filename) {

        if (!$handle = fopen($filename, 'a')) {
            throw new UserFormException("Error - cannot open. File: " . $filename . " ( CWD: " . getcwd() . ")", ERROR_IO_OPEN);
        }

        if (fwrite($handle, $msg . PHP_EOL) === FALSE) {
            throw new UserFormException("Error - cannot write. File: " . $filename . " ( CWD: " . getcwd() . ")", ERROR_IO_WRITE);
        }

        fclose($handle);
    } // logMessage()

    /**
     * @param array $fe
     * @return string
     */
    public static function formatFormElementName(array $fe) {
        Support::setIfNotSet($fe, 'id');
        Support::setIfNotSet($fe, FE_NAME);
        Support::setIfNotSet($fe, FE_LABEL);

        return $fe['id'] . ' / ' . $fe[FE_NAME] . ' / ' . $fe[FE_LABEL];
    }
}